/*
* $Irpd.c:Danny H. Newport:5-19-03
*
* Danny H. Newport
* compiled with AvrEdit Ver. 3.5 using 20% memory (room for expansion)
*
*	Main Parts
*		AVR 2313 @ 4mhz
*		
*    Note:
*         I needed to tie ir sensor output to gnd through a 1uF cap to
*    get the output to give a valid signal otherwise the led would just
*    flash instead of staying on.
*
*    I have not actually built a circuit with this diagram yet, so it has
*    only been proto-typed, but seems to work ok for my needs.
*
*	Port layout
* 		PORTB	Pin0	
*				Pin1	
*				Pin2	Ir led         low  = led on
*				Pin3	
*				Pin4	Led output     low  = object found indication
*                   Pin5 
*                   Pin6 
*                   Pin7 
*		PORTD
*				PD0		TX	
*				PD1		RX
                    PD2       ir sensor high = object found
*				
*
*   This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.   
*
*
*	Special Thanks.
*		AVR GCC team for a great compiler
*		AvrEdit for a great avr ide setup
*		Atmel for the versitile Micro.    
* 
*/

#include <io.h>
#include <interrupt.h>
#include <sig-avr.h>
#include <timer.h>
#define __AVR_AT90S2313__


//defines for delay
#define CPU_freq    4000000						//cpu clock frequency
#define CYCLES_PER_US ((CPU_freq+500000)/100000) 	// cpu cycles per microsecond
#undef ECHO
#define UART_BAUD_RATE 9600
#define UART_BAUD_SELECT ((CPU_freq/(UART_BAUD_RATE*16))-1)


typedef unsigned char  u08;

/* uart globals */
/*static volatile u08 *uart_data_ptr;
static volatile u08 uart_counter;*/

/* global variables for delay functions */
uint16_t delay_count=CPU_freq/4000;				// used in delay function

/* prototypes */

void delay_us(unsigned short us);

/* global variables for serial port */
volatile uint8_t ready = 0;

/*
* Set default values
*/
void init(void)
{
	
	
}


/*
* uart transmit complete isr
*/
INTERRUPT (SIG_UART_TRANS)
{
	ready = 1;
}


// millisecond delay function
void delay_ms(uint8_t ms)
{
	uint16_t cnt; asm volatile (
		
		"\n" "L_dl1%=:" "\n\t" "mov %A0, %A2" "\n\t" "mov %B0, %B2" "\n" "L_dl2%=:" "\n\t"
		
		"sbiw %A0, 1" "\n\t" "brne L_dl2%=" "\n\t" "dec %1" "\n\t" "brne L_dl1%=" "\n\t" : "=&w" (cnt) : "r" (ms), "r" (delay_count) );
}

/*
*  function for endless loop
*/
void main_loop (void)
{
	uint8_t loop=0;         //40khz pulse loop
     uint8_t result=0;        //check result of ir receiver

    

	for (;;)
	{
         
          for(loop=0;loop<35;loop++)//send a 40khz pulse
          {
          cbi(PORTB,PINB2);
          delay_us(5);
          sbi(PORTB,PINB2);
          delay_us(5);
          }

          result=0;                     //default result to none

          delay_ms(1);                  //wait for ir bounce

          for(loop=0;loop<10;loop++)//check for sense
          {
           if(bit_is_clear(PIND,PIND2)==1)
               result+=1;

          }
               if(result>1)//output led if sensor found object
               {
               cbi(PORTB,PINB4);
               }
               else
               {
               sbi(PORTB,PINB4);
               }
          }
    
}



/*
*
*/
int
main (void)
{
	init();
	
	outp (0xff, DDRB);			/* portb = OUTPUT */
	outp (0x00, DDRD);			/* portd = INPUT*/
	
	outp ((1 << TXCIE) | (1 << RXEN) | (1 << TXEN), UCR);
	//outp (64, UBRR);//use this for 10mhz
	outp (25, UBRR);//use this for 4mhz
	sei ();						/* enable interrupts */
	main_loop ();
	return 0;
}



/*void delay_ms(char delay_time)
{
int c;
for(c = 0; c < (CPU_freq / 40000); c++)
{
}
}*/

// microsecond delay function
void delay_us(unsigned short us)
{
     unsigned short  delay_loops;
     register unsigned short  i;

     delay_loops = (us+3)/5*CYCLES_PER_US; // +3 for rounding up (dirty)
  
	// one loop takes 5 cpu cycles
	for (i=0; i < delay_loops; i++) {};
}
